<?php
namespace Teknisa\CNC\Factories;

use Doctrine\ORM\EntityManager;
use Teknisa\CNC\Query;

class Cnc00100CriterioFactory {
    protected $queries;
    protected $connection;

    public function __construct(EntityManager $entityManager, Query\Query $queries) {
        $this->connection = $entityManager->getConnection();
        $this->queries = $queries;
    }
    
    public function getStandarts($params){
        $sql = $this->queries::GET_STANDARS;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function getEstabelecStandarts($params){
        $sql = $this->queries::GET_ESTABELEC_STANDARTS;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getOrderStandard($params){
        $sql = $this->queries::GET_ORDERS_STANDARD;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getEstabelecStandard($params){
        $sql = $this->queries::GET_ESTAB_STAND;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function validateOrderStandartsIns($params){
        $sql = $this->queries::VALIDATE_ORDER_STANDARTS_INS;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function validateOrderStandartsUpdt($params){
        $sql = $this->queries::VALIDATE_ORDER_STANDARTS_UPDT;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getOrderStandarts($params){
        $sql = $this->queries::GET_ORDER_STANDARTS;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function validateOrderStandartsEstIns($params){
        $sql = $this->queries::VALIDATE_ORDER_STANDARTS_EST_INS;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function validateOrderStandartsEstUpdt($params){
        $sql = $this->queries::VALIDATE_ORDER_STANDARTS_EST_UPDT;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getOrderStandartsEst($params){
        $sql = $this->queries::GET_ORDER_STANDARTS_EST;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getOrderStandartsCad($params){
        $sql = $this->queries::GET_ORDER_STANDARTS_CAD;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getOrderStandartsEstCad($params){
        $sql = $this->queries::GET_ORDER_STANDARTS_EST_CAD;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function updateOrderStandarts($params){
        $sql = $this->queries::UPDATE_ORDERS_STANDARTS;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function updateOrderStandartsEst($params){
        $sql = $this->queries::UPDATE_ORDERS_STANDARTS_EST;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function insertOrderStandarts($params){
        $sql = $this->queries::INSERT_ORDER_STANDARTS;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function insertOrderStandartsEst($params){
        $sql = $this->queries::INSERT_ORDER_STANDARTS_EST;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function clearOrderStandarts($params){
        $sql = $this->queries::CLEAR_ORDER_STANDARTS;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function clearEstabelecStandarts($params){
        $sql = $this->queries::CLEAR_ESTABELEC_STANDARTS;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function clearOrderStandartsEst($params){
        $sql = $this->queries::CLEAR_ORDER_STANDARTS_EST;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
}
