<?php

namespace Teknisa\CNC\Factories;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Teknisa\CNC\Query;

class Cnc00400ConciliacaoManualFactory {
    protected $connection;
    protected $queries;
    
    public function __construct(EntityManager $entityManager, Query\Query $queries) {
        $this->connection = $entityManager->getConnection();
        $this->queries = $queries;
    }
    
    public function leftGridSelect ($params) {
        $sql = $this->queries::LEFT_GRID_SELECT;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function rightGridSelect ($params) {
        $sql = $this->queries::RIGHT_GRID_SELECT;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function rightGridSelectVisibleProducts ($params) {
        $sql = $this->queries::RIGHT_GRID_SELECT_VISIBLE_PRODUCTS;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function selectConciliacoesPagto ($params) {
        $sql = $this->queries::SELECT_CONCILIACOES_PAGTO;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function selectTabSisMovimentacoes ($params) {
        $sql = $this->queries::SELECT_TAB_SIS_MOVIMENTACOES;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function selectTabAdqMovimentacoes ($params) {
        $sql = $this->queries::SELECT_TAB_ADQ_MOVIMENTACOES;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function selectTabVndMovimentacoes ($params) {
        $sql = $this->query::SELECT_TAB_VND_MOVIMENTACOES;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function selectTabRetMovimentacoes ($params) {
        $sql = $this->queries::SELECT_TAB_RET_MOVIMENTACOES;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function selectRetVendaInfo ($params) {
        $sql = $this->queries::SELECT_RET_VENDA_INFO;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll()[0];
    }
    
    public function checkItemCorrecao ($params) {
        $sql = $this->queries::CHECK_ITEM_CORRECAO;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function updateConsWithVndValues ($params) {
        $sql = $this->queries::UPDATE_CONS_WITH_VND_VALUES;
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function apagaContasPrevistas ($params) {
        $bool = true;
        
        $sql = $this->queries::APAGA_CONTAS_PREVISTAS_FROM_LANCCONT;
        $std  = $this->connection->prepare($sql);
        
        $bool = $bool && $std->execute($params);
        
        $sql = $this->queries::APAGA_CONTAS_PREVISTAS_FROM_AJCTRECEBER;
        $std  = $this->connection->prepare($sql);

        $bool = $bool && $std->execute($params);
        
        $sql = $this->queries::APAGA_CONTAS_PREVISTAS_FROM_CONTARECEBER;
        $std  = $this->connection->prepare($sql);
        
        $bool = $bool && $std->execute($params);
        
        $sql = $this->APAGA_CONTAS_PREVISTAS_SELECT_BOLETRECEBER_WITH_CONTARECEBER;
        $std  = $this->connection->prepare($sql);
        $std->execute($params);
        $resultSet = $std->fetchAll();
        
        foreach($resultSet as $resultLine) {
            $sql = $this->queries::APAGA_CONTAS_PREVISTAS_DELETE_BOLETRECEBER_WITH_NRLANBOLREC;
            $std  = $this->connection->prepare($sql);
            
            $bool = $bool && $std->execute(array(
                ":CDFILIAL"    => $resultLine["CDFILIAL"],
                ":NRLANBOLREC" => $resultLine["NRLANBOLREC"]
            ));
        }
        
        $sql = $this->queries::APAGA_CONTAS_PREVISTAS_UPDATE_RETVENDAADQ;
        $std  = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function updateConsMovCaixaBeforeDelete ($params) {
        $sql = $this->queries::UPDATE_CONS_MOV_CAIXA_BEFORE_DELETE;
        $std  = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function deleteFromNotaFiscal ($params) {
        $sql = $this->queries::DELETE_FROM_NOTA_FISCAL;
        $std  = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function nullifyRowsAtRetVendaAdq ($params) {
        $sql = $this->queries::NULLIFY_ROWS_AT_RETVENDA;
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function nullifyConcPgtoAtRetVendaAdq ($params) {
        $sql = $this->queries::NULLIFY_CONC_PAGTO_AT_RETVENDA;
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function nullifyRowsAtRetFinancAdq ($params) {
        $sql = $this->queries::NULLIFY_ROWS_AT_RETFINANC;
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function nullifyRowsAtConsMovCaixa ($params) {
        $sql = $this->queries::NULLIFY_ROWS_AT_CONSMOVCAIXA;
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    } 
    
    public function deleteFromDivConciliacaoConvmovcaixa ($params) {
        $sql = $this->queries::DELETE_FROM_DIVCONCILIACAO_WITH_NRCONSMOVCAIXA;
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function deleteFromDivConciliacao ($params) {
        $sql = $this->queries::DELETE_FROM_DIVCONCILIACAO;
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function deleteFromConciliacaoLanc ($params) {
        $sql = $this->queries::DELETE_FROM_CONCILIACAOLANC;
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function insertAtConciliacaoLanc ($params) {
        $sql = $this->queries::INSERT_AT_CONCILIACAOLANC;
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function deleteItemCorVenda ($params) {
        $sql = $this->queries::DELETE_ITEMCORVENDA;
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function insertItemCorVenda ($params) {
        $sql = $this->queries::INSERT_ITEMCORVENDA;
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function updateRetVendaAdq ($params) {
        $sql = $this->queries::UPDATE_RETVENDAADQ;
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function updateRetVendaAdqLanctoNf ($params) {
        $sql = $this->queries::UPDATE_RETVENDAADQ_NRLANCTONF;
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function updatePgtoRetVendaAdq ($params) {
        $sql = $this->queries::UPDATE_PGTO_RETVENDAADQ;
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function updateConsMovCaixa ($params) {
        $sql = $this->queries::UPDATE_CONSMOVCAIXA;
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function updateRetFinancAdq ($params) {
        $sql = $this->queries::UPDATE_RETFINANCADQ;
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function getErrors($params){
        $sql = "SELECT COUNT(*) QT
                              FROM ERROCTBTEMP
                             WHERE CDEMPRESA = :CDEMPRESA
                               AND NRLANCCTBTEMP = :NRLANCCTBTEMP"; 
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getError($params){
        $sql = $this->queries::GET_ERRORS;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function deleteErrors($params){
        $sql = $this->queries::DELETE_ERROR_FROM_ERROCTBTEMP;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        $sql = $this->queries::DELETE_ERROR_FROM_LANCCTBTEMP;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        $sql = $this->queries::DELETE_ERROR_FROM_RATECTBTEMP;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
    }
    
    public function verificaGeraFinanc($params){
        $sql = $this->queries::VERIFICA_GERAFINANC;
        $std = $this->connection->prepare($sql);
        $std->execute($params);     
        return $std->fetch();
        
    }
    
    public function getNameProdutoadq($param){
        $sql = $this->queries::GET_NAME_PRODUTOADQ;
        $std = $this->connection->prepare($sql);
        $std->execute($param);
        return $std->fetch();
    }

    public function searchParamsCnc($params){
        try{ 
            switch($params[':P_TIPOPARAM']){
                case 'TIPODEB':
                    $sql = $this->queries::SEARCH_PARAMS_CNC_TIPODEB;
                    break;            
                case 'TIPOCRED':
                    $sql = $this->queries::SEARCH_PARAMS_CNC_TIPOCRED;
                    break;                  
                case 'TIPOCONTA':
                    $sql = $this->queries::SEARCH_PARAMS_CNC_TIPOCONTA;
                    break;
                case 'TIPOAJUSTE':
                    $sql = $this->queries::SEARCH_PARAMS_CNC_TIPOAJUSTE;
                    break;
                case 'TIPOOPER':
                    $sql = $this->queries::SEARCH_PARAMS_CNC_TIPOOPER;
                    break;
                
            }
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetch();
        } catch (\Exception $e) {
                throw $e;
        }
    }
    
    public function verifyInfoConsmov($param){ 
        $sql = $this->queries::VERIFY_INFO_CONSMOV;
        $std = $this->connection->prepare($sql);
        $std->execute($param);
        $retorno = $std->fetch();
        
        if(empty($retorno)){
            try{
                // verifica se possui CDCLIENTE parametrizado no tipo de recebimento
                $this->verifyCDCLIENTE(array(
                    ":NRCONSMOVCAIXA" => $param[":NRCONSMOVCAIXA"]
                ));
                
                $procedure = new StoredProcedure($this->connection, 'FINANCEIRO_FOS_CNC');
                $procedure->addParam(new Param('P_NRCONSMOVCAIXA', Param::PARAM_INPUT, $param[':NRCONSMOVCAIXA']));
                $procedure->execute();
                $std = $this->connection->prepare($sql);
                $std->execute($param);
                $retorno = $std->fetch();
            } catch (\Exception $e) {
                throw $e;
            }
        }
        return $retorno;
    }
    
    public function verifyCDCLIENTE($condition) {
        $query = $this->queries::VERIFY_CDCLIENTE_TIPORECE;
        $std = $this->connection->prepare($query);
        $std->execute($condition);
        $cdcliente = $std->fetch();
        
        if(!$cdcliente) {
            throw new \Exception("Não foi possível desconciliar movimentações, pois o tipo de Recebimento não possui Cliente parametrizado!");
        }
    }
    
    public function updateNotaFiscal($params){
        try{
            $sql = $this->queries::UPDATE_NOTA_FISCAL;
            $std = $this->connection->prepare($sql);
            $std->execute($params);
        } catch(\Exception $e){
            throw $e;
        }
    }
    
    public function updateContaReceber($params){
        try{
            $sql = $this->queries::UPDATE_CONTA_RECEBER;
            $std = $this->connection->prepare($sql);
            $std->execute($params);
        } catch(\Exception $e){
            throw $e;
        }
    }
    
    public function updateContaReceberGeral($params){
        try{
            $sql = $this->queries::UPDATE_CONTA_RECEBER_GERAL;
            $std = $this->connection->prepare($sql);
            $std->execute($params);
        } catch(\Exception $e){
            throw $e;
        }
    }

    public function findNrestabelec($params){
        try{
            $sql = $this->queries::FIND_NRESTABELEC;
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetch();
            
        } catch(\Exception $e){
            throw $e;
        }
    }
    
    public function findNrproduto($params){
        if(isset($params[':NMPRODUTOADQ'])){
            try{
            $sql = $this->queries::FIND_NRPRODUTO;
            $std = $this->connection->fetchAssoc($sql, $params);
            
            if(!is_bool($std)){
                return $std;
            }

            } catch(\Exception $e){
                throw $e;
            }
        } else {
            throw new \Exception("Não foi possível encontrar o NRPRODUTOADQ'.", 1);
        }
        
    }
    
    public function findVendasConciliadas($params){
        try{
            $sql = $this->queries::FIND_VENDAS_CONCILIADAS;
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetch();
        } catch(\Exception $e){
            throw $e;
        }
    }
    
    public function contabilizaContaCnc($params){
      try{ 
            $procedure = new StoredProcedure($this->connection, 'CONTABILIZA_CONTAS_CNC');
            $procedure->addParam(new Param('CDFILIAL', Param::PARAM_INPUT, $params["CDFILIAL"]));
            $procedure->addParam(new Param('DTVENDA', Param::PARAM_INPUT, $params["DTVENDA"]));
            $procedure->addParam(new Param('CDTIPORECE', Param::PARAM_INPUT, $params["CDTIPORECE"]));
         
            return $procedure->execute();
        } catch (\Exception $e) {
                throw $e;
        }
    }
    
    public function findVendasConciliadasOld($params){
        $sql = $this->queries::FIND_VENDAS_CONCILIADAS_OLD;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
    
    public function insertDivergenciaConciliacao($params){
        $sql = $this->queries::INSERT_DIVERGENCIA_CONCILIACAO;
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function checkItemDivergencia($DSTIPODIV){
        $sql = $this->queries::CHECK_ITEM_DIVERGENCIA;
        $std = $this->connection->prepare($sql);
        $std->execute($DSTIPODIV);
        return $std->fetchAll();
    }
    
    public function verificaDataPeriodoContabil($params){
        $sql = $this->queries::VERIFICA_DATA_PERIODO_CONTABIL;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
        
    }
    
    public function verificaDataControleFinanc($params){
        $sql = $this->queries::VERIFICA_DATA_CONTROLE_FINANC;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        $retorno = $std->fetch()["DATA"];
        
        if (empty($retorno) || $retorno == null || $retorno == '') {
            return 0;
        } else {
            return $retorno;
        }
        
    }
    
    public function verificaDataControleFinancFilial($params){
        $sql = $this->queries::VERIFICA_DATA_CONTROLE_FINANC_FILIAL;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        $retorno = $std->fetch();
        
        if(empty($retorno) || $retorno == null || $retorno == '') {
            return 0;
        } else {
            return $retorno['DATA'];
        }
        
    }
    
    public function verificaEmpresaDataVenda($params){
        $sql = $this->queries::VERIFICA_EMPRESA_DATA_VENDA;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
        
    }
    
    public function deleteDivConciliacao ($params) {
        $sql = $this->queries::DELETE_DIV_CONCILIACAO;
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }

    public function existBoletRec($params){
        $sql = $this->queries::EXIST_BOLET_REC;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }

    public function recalculaTotalBoleto($params){
        $sql = $this->queries::RECALCULA_TOTAL_BOLETO;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
    
    public function updateBoletReceber($params){
        $sql = $this->queries::UPDATE_BOLETO_RECEBER;
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function getCdclienteByTiporece($params){
        $sql = $this->queries::GET_CDCLIENTE_BY_TIPORECE;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
    
    public function verifyContaReceberInfo($params){
        $sql = $this->queries::VERIFY_CONTA_RECEBER_INFO;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
    
    public function recalculaBoleto($params){
        $sql = $this->queries::RECALCULA_BOLETO;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }

    public function verifyBoletReceberInfo($params){
        $sql = $this->queries::VERIFY_BOLETO_RECEBER_INFO;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
    
    public function getMovCaixa($params){
        $sql = $this->queries::GET_MOV_CAIXA;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
    
    public function updateConsMovCaixaDesconciliacao($params){
        $sql = $this->queries::UPDATE_CONSMOVCAIXA_DESCONCILIACAO;
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function nullifyBoletContaReceber($params){
        $sql = $this->queries::NULLIFY_BOLETO_RECEBER;
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function clearBolRecebFromContaReceb($params){
        $sql = $this->queries::CLEAR_BOLRECEB_FROM_CONTARECEB;
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function calcNrDiasVenc($params){
        $sql = $this->queries::CALC_NRDIASVENC;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();    
        
    }
    
    public function verifyDataVenc($params){
        $sql = $this->queries::VERIFY_DATAVENC;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();    
        
    }
    
    public function updateContaReceberBol($params){
        $sql = $this->queries::UPDATE_CONTA_RECEBER_BOL;
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
        
    }
    
    public function updateTprecboleto($params){
        $sql = $this->queries::UPDATE_TPRECBOLETO;
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
        
    }

    public function deleteBoletReceber($params){
        $sql = $this->queries::DELETE_BOLETRECEBER;
        $std  = $this->connection->prepare($sql);
        return $std->execute($params);
    }

    public function deleteTiporeceBolet($params){
        $sql = $this->queries::DELETE_TPRECBOLETO;
        $std  = $this->connection->prepare($sql);
        return $std->execute($params);
    }

    public function upateBoletoConta($params){
        $sql =     $this->queries::UPDATE_BOLETO_CONTA;
        $std  = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function createBoletRec($params){
      try{ 
            $procedure = new StoredProcedure($this->connection, 'GERA_BOLETOS_REC');
            $procedure->addParam(new Param('P_NRLANBOLREC', Param::PARAM_INPUT, $params["P_NRLANBOLREC"]));
            $procedure->addParam(new Param('P_CDFILIAL', Param::PARAM_INPUT, $params["P_CDFILIAL"]));
            $procedure->addParam(new Param('P_CDCLIENTE', Param::PARAM_INPUT, $params["P_CDCLIENTE"]));
            $procedure->addParam(new Param('P_CDEMPRESA', Param::PARAM_INPUT, $params["P_CDEMPRESA"]));
            $procedure->addParam(new Param('P_VRBOLREC', Param::PARAM_INPUT, $params["P_VRBOLREC"]));
            $procedure->addParam(new Param('P_DTVENBOL', Param::PARAM_INPUT, $params["P_DTVENBOL"]));
            $procedure->addParam(new Param('P_CDTIPORECE', Param::PARAM_INPUT, $params["P_CDTIPORECE"]));
            $procedure->addParam(new Param('P_NRCHEQUEVEND', Param::PARAM_INPUT, $params["P_NRCHEQUEVEND"]));
            $procedure->addParam(new Param('P_CDBANCHEQVEN', Param::PARAM_INPUT, $params["P_CDBANCHEQVEN"]));
            $procedure->addParam(new Param('P_CDAGECHEQVEN', Param::PARAM_INPUT, $params["P_CDAGECHEQVEN"]));
            $procedure->addParam(new Param('P_CDCNTCHEQVEN', Param::PARAM_INPUT, $params["P_CDCNTCHEQVEN"]));
            $procedure->addParam(new Param('P_CDREDUCONT', Param::PARAM_INPUT, $params["P_CDREDUCONT"]));
            $procedure->addParam(new Param('P_CDTPBAIXA', Param::PARAM_INPUT, $params["P_CDTPBAIXA"]));
            $procedure->addParam(new Param('P_DTVENDAECF', Param::PARAM_INPUT, $params["P_DTVENDAECF"]));

            return $procedure->execute();
        } catch (\Exception $e) {
                throw $e;
        }
    }
    
    public function verifyInfoTpReceb($params){
        $sql = $this->queries::VERIFY_INFO_TIPORECE;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();    
        
    }
    
    public function refazTaxaServFinanc($params) {
        try{ 
            $procedure = new StoredProcedure($this->connection, 'REFAZ_REC_TAXASERV_CNC');
            $procedure->addParam(new Param('P_NRCONSMOVCAIXA', Param::PARAM_INPUT, $params[":NRCONSMOVCAIXA"]));

            return $procedure->execute();
        } catch (\Exception $e) {
                throw $e;
        }
    }
    
    public function getCdcliente($nradquirente){
        $sql = $this->queries::GET_CDCLIENTE;
        $std = $this->connection->prepare($sql);
        $std->execute($nradquirente);     
        return $std->fetch();
        
    }
    
    public function updateClienteNf($params){
        try{
            $sql = $this->queries::UPDATE_CLIENTE_NF;
            $std = $this->connection->prepare($sql);
            $std->execute($params);
        } catch(\Exception $e){
            throw $e;
        }
    }

    public function updateContRecebDesc ($params) {
        $sql = $this->queries::UPDATE_CONTRECEB_DESC;
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function verifyContReceb($params){
        $sql = $this->queries::VERIFY_CONTRECEB;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
    
    public function buscaBoleto($params){
        $sql = $this->queries::BUSCA_BOLETO;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
    
    public function verifyAjusteBoleto($params){
        $sql = $this->queries::VERIFY_AJU_BOLETO;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
    
    public function updateBoletReceberValor($params){
        $sql = $this->queries::UPDATE_BOLETO_RECEBER_VALOR;
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }

}